unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, shellapi, DB, DBTables, Grids,
  DBGrids, CalcPvd, ArtRepProvider, ExcelPvd, artreport, DBClient, ComCtrls;

type
  TMainForm = class(TForm)
    Label1: TLabel;
    R1: TRadioButton;
    R2: TRadioButton;
    R3: TRadioButton;
    R4: TRadioButton;
    R5: TRadioButton;
    R6: TRadioButton;
    P: TPanel;
    Label2: TLabel;
    EdBut: TButton;
    CRBut: TButton;
    Label3: TLabel;
    Comment: TEdit;
    R7: TRadioButton;
    R8: TRadioButton;
    Label4: TLabel;
    pvds: TComboBox;
    Excel: TARExcelProvider;
    Calc: TARCalcProvider;
    cbVisible: TCheckBox;
    cbOutline: TCheckBox;
    cbEmpty: TCheckBox;
    Ar: TArtXLSReport;
    Panel1: TPanel;
    Label5: TLabel;
    SheetName: TEdit;
    PB: TProgressBar;
    procedure R1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure EdButClick(Sender: TObject);
    procedure CRButClick(Sender: TObject);
    procedure ARGetValue(name: PAnsiChar; var Val: Variant);
    procedure pvdsChange(Sender: TObject);
    procedure ArProgress(num, total: Integer);
  private
  public
    templname,path:string;
    idx,m : integer;
    d1 : TDate;
  end;

var
  MainForm: TMainForm;

implementation

uses data, dates, DateUtils, strutils;

{$R *.dfm}

procedure TMainForm.R1Click(Sender: TObject);
begin
 P.Caption := (Sender as TRadioButton).Hint;
 idx := (sender as tcomponent).tag;
 case (sender as tcomponent).tag of
 1: templname := path+'templates\'+'simple.xlt';
 2: templname := path+'templates\'+'detail.xlt';
 3: templname := path+'templates\'+'group.xlt';
 4: templname := path+'templates\'+'subdetail.xlt';
 5: templname := path+'templates\'+'subgroup.xlt';
 6: templname := path+'templates\'+'multicolumn.xlt';
 7: templname := path+'templates\'+'multisheet.xlt';
 8: templname := path+'templates\'+'complex.xlt';
 end;

end;

procedure TMainForm.FormShow(Sender: TObject);
begin
 path := extractfilepath(Application.ExeName);
 if Excel.Installed then pvds.AddItem(Excel.ProviderName, Excel);
 if Calc.Installed then pvds.AddItem(Calc.ProviderName, Calc);
 if pvds.Items.Count = 0 then Application.MessageBox('No spreadsheet providers found','Error',mb_iconstop)
 else
 begin
  pvds.Itemindex := 0;
  EdBut.Enabled := true;
  CRBut.Enabled := true;
 end;
 R1click(r1);
 pvdsChange(self);
end;

procedure TMainForm.EdButClick(Sender: TObject);
begin
 ShellExecute(handle,'open',pchar(templname),'','',sw_maximize);
end;

procedure TMainForm.ArProgress(num, total: Integer);
begin
 PB.Max := total;
 PB.Position := num;
 Application.ProcessMessages;
end;

procedure TMainForm.CRButClick(Sender: TObject);
var i,mm:integer;
    s : string;
begin

 PB.Position := 0;
 ar.Template := templname;
 ar.SheetName := SheetName.Text;
 ar.SaveAs := '';
 ar.Visible := cbVisible.Checked;
 ar.Grouping := cbOutline.Checked;
 ar.SubGrouping := cbOutline.Checked;
 ar.ShowEmpty := cbEmpty.Checked;
 ar.ShowEmptySub := cbEmpty.Checked;

 case idx of
 1:
 begin
  AR.MasterSource := dm.CountryDS;
  dm.Country.Open;
  ar.Report;
  dm.Country.Close;
 end;
 2:
 begin

  AR.MasterSource := dm.CustomerDC;
  AR.DetailSource := dm.OrderDS;
  AR.MasterField := 'custno';
  AR.DetailField := 'custno';
  dm.Customer.Open;
  dm.Order.Open;
  ar.Report;
  dm.Customer.Close;
  dm.Order.Close;

 end;
 3:
 begin
  AR.MasterSource := dm.SQLDS;
  dm.SQL.SQL.Clear;
  dm.SQL.SQL.Add('select substring(company from 1 for 1) as grp, company, addr1, city, state, zip, country, phone, fax from customer.db');
  dm.SQL.SQL.Add('order by company');
  AR.Groupfield := 'Grp';
  dm.SQL.Open;
  ar.Report;
  dm.SQL.close;
 end;
 4:
 begin
  dm.Events.IndexDefs.Update;
  if dm.Events.IndexDefs.GetIndexForFields('venueno',false) = nil then
  begin
   dm.Events.AddIndex('VenueNo','VenueNo',[]);
  end;
  dm.Events.IndexFieldNames := 'VenueNo';
  AR.MasterSource := dm.VenuesDS;
  AR.DetailSource := dm.EventsDS;
  AR.SubDetailSource := dm.ReservantDS;
  AR.MasterField := 'venueno';
  AR.DetailField := 'venueno';
  AR.SubDetailField := 'eventno';
  AR.SubMasterField := 'eventno';
  dm.Venues.Open;
  dm.Events.Open;
  dm.Reservant.Open;
  dm.Custoly.Open;
  ar.Report;
  dm.Venues.Close;
  dm.Events.Close;
  dm.Reservant.Close;
  dm.Custoly.Close;
 end;
 5:
 begin
  AR.MasterSource := dm.SQLDS;
  dm.SQL.SQL.Clear;
  dm.SQL.SQL.Add('select * from customer a, orders b, items c, parts d');
  dm.SQL.SQL.Add('where a.custno = b.custno');
  dm.SQL.SQL.Add('and b.orderno = c.orderno');
  dm.SQL.SQL.Add('and c.partno = d.partno');
  dm.SQL.SQL.Add('order by a.company, orderno');
  AR.Groupfield := 'Company';
  Ar.SubGroupField := 'Orderno';
  dm.SQL.Open;
  ar.Report;
  dm.SQL.close;
 end;
 6:
 if (DatesForm.ShowModal = idok) and (DatesForm.D1.Date <= DatesForm.D2.Date) then
 begin
   dm.orders.Close;
   dm.orders.FieldDefs.Clear;
   dm.orders.FieldDefs.Add('CustNo', ftInteger);
   dm.orders.FieldDefs.Add('Customer', ftString, 50);
   dm.orders.FieldDefs.Add('Address', ftString, 250);

   d1 := EncodeDate(YearOf(DatesForm.D1.Date),MonthOf(DatesForm.D1.Date),1);

   m := 1 + YearOf(DatesForm.D2.Date)*12+MonthOf(DatesForm.D2.Date)-
     YearOf(DatesForm.D1.Date)*12-MonthOf(DatesForm.D1.Date);


   for I := 1 to m do
     dm.orders.FieldDefs.Add('month'+inttostr(i), ftCurrency);
   dm.orders.CreateDataSet;
   dm.orders.IndexFieldNames := 'Custno';
   dm.orders.Open;
   dm.SQL.SQL.Clear;
   dm.SQL.SQL.Add('select O.Saledate, O.itemstotal, C.Custno, C.Company, C.addr1, C.addr2, C.city, C.state, C.zip, C.country from customer C, orders O');
   dm.SQL.SQL.Add('where O.custno = C.custno');
   dm.SQL.SQL.Add('and o.saledate between "'+FormatDateTime('mm"/"dd"/"yyyy',DatesForm.D1.Date)+'" and "'+FormatDateTime('mm"/"dd"/"yyyy',DatesForm.D2.Date)+'"');
   dm.SQL.Open;
   if dm.SQL.RecordCount = 0 then
   begin
     Application.MessageBox('Data not found!','No data',mb_iconstop);
     exit;
   end;

   Ar.Columns := m;
   mm := YearOf(DatesForm.D1.Date)*12+MonthOf(DatesForm.D1.Date)-1;

   while not DM.SQL.Eof do
   begin
     if not dm.orders.locate('custno',dm.SQL.FieldByName('custno').AsInteger,[]) then
     begin
       dm.orders.Append;
       dm.orders.FieldByName('CustNo').AsInteger := dm.SQL.FieldByName('custno').AsInteger;
       dm.orders.FieldByName('Customer').AsString := dm.SQL.FieldByName('company').Asstring;
       dm.orders.FieldByName('Address').AsString := dm.SQL.FieldByName('Country').Asstring+' '+
        dm.SQL.FieldByName('Zip').Asstring+' '+dm.SQL.FieldByName('State').Asstring+' '+
        dm.SQL.FieldByName('City').Asstring+' '+dm.SQL.FieldByName('Addr1').Asstring+' '+
        dm.SQL.FieldByName('Addr2').Asstring;
     end
     else
       dm.orders.Edit;
     i :=  YearOf(dm.SQL.FieldByName('SaleDate').AsDateTime)*12+MonthOf(dm.SQL.FieldByName('SaleDate').AsDateTime)-mm;
     dm.orders.FieldByName('month'+inttostr(i)).AsCurrency :=
     dm.orders.FieldByName('month'+inttostr(i)).AsCurrency + dm.SQL.FieldByName('ItemsTotal').AsCurrency;
     dm.orders.Post;
     dm.SQL.Next;
   end;

   dm.orders.IndexFieldNames := 'Customer';
   ar.MasterSource := dm.ordersDS;
   ar.Report;
   dm.Sql.Close;
   dm.Orders.Close;
 end;
 7:
 begin
   idx := 2;
   ar.ShowReport := false;
   CRButClick(Self);
   idx := 3;
   ar.Page := 2;
   ar.ShowReport := true;
   templname := ChangeFileExt(templname,'.xls');
   s := SheetName.Text;
   SheetName.Text := SheetName.Text+'2';
   CRButClick(Self);
   ar.Page := 0;
   R1Click(R7);
   SheetName.Text := s;
 end;
 8:
 begin
   idx := 4;
   ar.ShowReport := false;
   CRButClick(Self);
   idx := 5;
   ar.Page := 1;
   ar.MasterRangeName := 'BaseX';
   ar.RangeName := 'BaseX';
   ar.SubRangeName := 'BaseX';
   ar.ShowReport := true;
   templname := ChangeFileExt(templname,'.xls');
   CRButClick(Self);
   ar.Page := 0;
   ar.MasterRangeName := 'Base';
   ar.RangeName := 'Base';
   ar.SubRangeName := 'Base';
   R1Click(R8);
 end;

 end;



 if ar.Error <> '' then Application.MessageBox(pchar(ar.Error),'Error',mb_iconwarning);

end;

procedure TMainForm.ARGetValue(name: PAnsiChar; var Val: Variant);
var i:integer;
begin
 Val := '';

 if name = 'TOTAL' then
 begin
   Val := '=RC[-1]';
   for I := 2 to m do
    Val := Val+'+RC['+inttostr(-i)+']';
 end
 else if leftstr(name,5) = 'MONTH' then
 begin
  i:=strtoint(rightstr(name,length(name)-5));
  Val := IncMonth(d1,i-1);
 end
 else if name = 'MCAPTION' then
  Val := 'Monthly orders report (from '+DateToStr(DatesForm.d1.date)+' to '
     +DateToStr(DatesForm.d2.date)+')'
 else if name = 'COMMENT' then Val := comment.Text
 else if name = 'SDNAME' then
 begin
  dm.Custoly.Locate('CustNo',dm.Reservant.FieldValues['custno'],[]);
  Val := dm.Custoly.FieldByName('Last_name').asstring+' '+
       dm.Custoly.FieldbyName('First_name').asstring;
 end
 else if name = 'SDPHONE' then
  Val := '    Phone: '+dm.Custoly.FieldbyName('Phone').AsString
 else if name = 'SDEMAIL' then
  Val := '    E-mail: '+dm.Custoly.Fieldbyname('EMail').AsString;
end;

procedure TMainForm.pvdsChange(Sender: TObject);
begin
 if pvds.ItemIndex >= 0 then
   AR.Provider := TArtRepProvider(pvds.Items.Objects[pvds.ItemIndex]);
end;

end.
