unit ArtRepProvider;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses Db,Classes,Variants;
                           
type

  TArtRepProvider = class(TComponent)
    procedure Connect; virtual; abstract;
    procedure SetVisible(visible:boolean); virtual; abstract;
    procedure OpenDoc(name:string; page:integer); virtual; abstract;
    procedure CreateDoc(name:string); virtual; abstract;
    procedure SetCalculation(auto:boolean); virtual; abstract;
    function GetCellText(row,col:integer) : string; virtual; abstract;
    procedure SetCellText(row,col:integer; txt:string); virtual; abstract;
    function GetCellFormula(row,col:integer) : string; virtual; abstract;
    procedure SetCellFormula(row,col:integer; Formula:Variant); virtual; abstract;
    procedure DeleteRow(row : integer); virtual; abstract;
    procedure DeleteRows(row,count : integer); virtual; abstract;
    procedure DeleteColumn(col : integer); virtual; abstract;
    procedure InsertColumns(col, count:integer); virtual; abstract;
    procedure CopyColumns(col, tocol, count:integer); virtual; abstract;
    procedure InsertRows(row, count:integer); virtual; abstract;
    procedure CopyRows(row, torow, count:integer); virtual; abstract;
    procedure Group(row, count : integer); virtual; abstract;
    procedure SetRange(R1,C1,R2,C2:integer; Data:Variant); virtual; abstract;
    procedure AddNameRange(R1,C1,R2,C2:integer; name:string); virtual; abstract;
    procedure AddName(name:string;val:integer); virtual; abstract;
    function LastUsedRow : integer; virtual; abstract;
    function DocLoaded : boolean; virtual; abstract;
    function LastUsedColumn : integer; virtual; abstract;
    procedure CleanUp; virtual; abstract;
    procedure AutoFit(col : integer); virtual; abstract;
    procedure ActivateCell(row,col : integer); virtual; abstract;
    procedure ShowLevels(level : integer); virtual; abstract;
    procedure SetSheetName(name : string); virtual; abstract;
    procedure InsertPicture(row,col:integer; filename : string); virtual; abstract;
    procedure Run(macro : string); virtual; abstract;
    procedure Print(copies:integer=1); virtual; abstract;
    procedure SaveDocAs(s:string); virtual; abstract;
    procedure SaveDoc; virtual; abstract;
    procedure BeforeQuit; virtual; abstract;
    procedure CloseDoc; virtual; abstract;
    function Installed : boolean;  virtual; abstract;
    function ProviderName : string; virtual; abstract;
    procedure MarkSaved; virtual; abstract;
    procedure Quit; virtual; abstract;
    function GetMyVariant(Field: TField;str:boolean=true): OLEVariant; virtual; abstract;
    function GetDate(val : TdateTime): OLEVariant; virtual; abstract;
  end;


function colname(x:integer):string;

implementation

function colname(x:integer):string;
begin
 if x > 26 then result := chr(ord('A')+(x-1) div 26 - 1)+chr(ord('A')+(x-1) mod 26)
 else result := chr(ord('A') + x - 1)
end;
end.
